import { Types as ChainT } from "@rill/chain";
import { IncomingMessage, Server, ServerResponse, Types as HttpT } from "@rill/http";
import Rill from "./";
import Context from "./context";
export declare namespace Types {
    type Headers = HttpT.Headers;
    type SetupFunction = (app: Rill) => any;
    type SetupArg = SetupFunction | false | void;
    type NextFunction = ChainT.NextFunction;
    type MiddlewareFunction = (ctx: Context, next?: NextFunction) => any;
    type MiddlewareArg = Stack | MiddlewareFunction | Rill | false | void;
    interface Stack extends Array<MiddlewareArg> {
        [index: number]: MiddlewareArg;
    }
    type HttpRequestHandler = (this: Server, req: IncomingMessage, res?: ServerResponse) => any;
    type HttpListenHandler = (this: Server) => any;
    type MethodShortcut = (pathname: string | MiddlewareArg, ...middlewares: MiddlewareArg[]) => Rill;
    interface ListenOptions {
        ip?: string;
        port?: number;
        backlog?: number;
        tls?: any;
    }
}
